#ifndef STACK_HPP
#define STACK_HPP

#include <cstddef>

// Linked list based stack after Sedgewick and Wayne, Algorithms 4th ed, Algorithm 1.2

template <typename T>
class Stack {

public:

    ////////////////////////////////////
    class Node {
    public:
        T item;
        Node *next;
        };


    ////////////////////////////////////
    class iterator;
    friend class iterator;
    class iterator {

    public:

        iterator( Node *c );

        iterator& operator++();
        iterator operator++(int);

        T operator*();
        bool operator!=( typename Stack<T>::iterator );

    private:

        Node *curr;
        };

    ////////////////////////////////////

    Stack( void );
    ~Stack( void );

    void push( T &item );
    T pop( void );

    bool is_empty( void );
    size_t size( void );

    iterator begin( void );
    iterator end( void );

private:

    size_t N;
    Node *list;

    void resize( size_t new_max );
    };



#endif

